#include <stdio.h>
#include <stdlib.h>

// Fonction pour calculer la factorielle
long long factorial(int n) {
    if (n == 0 || n == 1) {
        return 1;
    } else {
        return n * factorial(n - 1);
    }
}

int main(int argc, char *argv[]) {
    // Vérifier le nombre d'arguments
    if (argc != 2) {
        fprintf(stderr, "error: Exactly one argument must be provided\n");
        return 1;
    }

    // Convertir l'argument en entier
    char *endptr;
    long n = strtol(argv[1], &endptr, 10);

    // Vérifier si la conversion a réussi
    if (*endptr != '\0' || n < 0 || n > 20) {
        fprintf(stderr, "error: The argument must be an integer between 0 and 20\n");
        return 1;
    }

    // Calculer la factorielle et l'afficher
    long long result = factorial((int)n);
    printf("%lld",result);

    return 0;
}
