#include <stdio.h>
#include <string.h>

#define MAX_DIMENSION 12

int searchWord(char grid[MAX_DIMENSION][MAX_DIMENSION], int dimension, char* word) {
    // Search horizontally
    for (int i = 0; i < dimension; ++i) {
        for (int j = 0; j <= dimension - strlen(word); ++j) {
            int match = 1;
            for (int k = 0; k < strlen(word); ++k) {
                if (grid[i][j + k] != word[k]) {
                    match = 0;
                    break;
                }
            }
            if (match) {
                return 1;  // Word found horizontally
            }
        }
    }

    // Search vertically
    for (int i = 0; i <= dimension - strlen(word); ++i) {
        for (int j = 0; j < dimension; ++j) {
            int match = 1;
            for (int k = 0; k < strlen(word); ++k) {
                if (grid[i + k][j] != word[k]) {
                    match = 0;
                    break;
                }
            }
            if (match) {
                return 1;  // Word found vertically
            }
        }
    }

    // Search diagonally
    for (int i = 0; i <= dimension - strlen(word); ++i) {
        for (int j = 0; j <= dimension - strlen(word); ++j) {
            int match = 1;
            for (int k = 0; k < strlen(word); ++k) {
                if (grid[i + k][j + k] != word[k]) {
                    match = 0;
                    break;
                }
            }
            if (match) {
                return 1;  // Word found diagonally
            }
        }
    }

    return 0;  // Word not found
}

int main() {
    char grid[MAX_DIMENSION][MAX_DIMENSION];
    int dimension;

    // Reading the grid from the "4x4hw.txt" file
    FILE *file = fopen("4x4hw.txt", "r");
    if (file == NULL) {
        perror("Error opening file");
        return 1;
    }

    fscanf(file, "%d", &dimension);
    for (int i = 0; i < dimension; ++i) {
        for (int j = 0; j < dimension; ++j) {
            fscanf(file, " %c", &grid[i][j]);
        }
    }

    fclose(file);

    // Searching for the specific word "LINUX"
    char word[] = "LINUX";

    if (searchWord(grid, dimension, word)) {
        printf("%s \n", word);
    } else {
        printf("%s not found in the grid.\n", word);
    }

    return 0;
}

