#!/usr/bin/env bats

setup() {
    load 'bats/bats-support/load'
    load 'bats/bats-assert/load'
}

# Test with an empty string
@test "empty string" {
    run_output ./mystery <<< ""
    assert_success
    assert_output ''
}

# Test with a string containing only spaces
@test "string of spaces" {
    run_output ./mystery <<< "     "
    assert_success
    assert_output ''
}

# Test with a string without unnecessary spaces
@test "string without unnecessary spaces" {
    run_output ./mystery <<< "Hello, World!"
    assert_success
    assert_output 'Hello, World!'
}

# Test with a string starting with spaces
@test "string with spaces at the beginning" {
    run_output ./mystery <<< "    Hello, World!"
    assert_success
    assert_output 'Hello, World!'
}

# Test with a string ending with spaces
@test "string with spaces at the end" {
    run_output ./mystery <<< "Hello, World!    "
    assert_success
    assert_output 'Hello, World!'
}

# Test with a string surrounded by spaces
@test "string surrounded by spaces" {
    run_output ./mystery <<< "    Hello, World!    "
    assert_success
    assert_output 'Hello, World!'
}

# Test with multiple spaces in the middle of the string
@test "string with spaces in the middle" {
    run_output ./mystery <<< "Hello,     World!"
    assert_success
    assert_output 'Hello,     World!'
}
#!/usr/bin/env bats

setup() {
    load 'bats/bats-support/load'
    load 'bats/bats-assert/load'
}

# Test with an empty string
@test "empty string" {
    run_output ./mystery <<< ""
    assert_success
    assert_output ''
}

# Test with a string containing only spaces
@test "string of spaces" {
    run_output ./mystery <<< "     "
    assert_success
    assert_output ''
}

# Test with a string without unnecessary spaces
@test "string without unnecessary spaces" {
    run_output ./mystery <<< "Hello, World!"
    assert_success
    assert_output 'Hello, World!'
}

# Test with a string starting with spaces
@test "string with spaces at the beginning" {
    run_output ./mystery <<< "    Hello, World!"
    assert_success
    assert_output 'Hello, World!'
}

# Test with a string ending with spaces
@test "string with spaces at the end" {
    run_output ./mystery <<< "Hello, World!    "
    assert_success
    assert_output 'Hello, World!'
}

# Test with a string surrounded by spaces
@test "string surrounded by spaces" {
    run_output ./mystery <<< "    Hello, World!    "
    assert_success
    assert_output 'Hello, World!'
}

# Test with multiple spaces in the middle of the string
@test "string with spaces in the middle" {
    run_output ./mystery <<< "Hello,     World!"
    assert_success
    assert_output 'Hello,     World!'
}
